VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmBOMSearch 
   Caption         =   "BOM-Search"
   ClientHeight    =   5790
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   8370
   OleObjectBlob   =   "frmBOMSearch.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frmBOMSearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim x As New Collection

Private Sub UserForm_Initialize()
    ' DropDown fllen
    Me.boxPName.AddItem "Position"
    Me.boxPName.AddItem "Quantity"
    Me.boxPName.AddItem "Remarks_for_Position"
    Me.boxPName.AddItem "Part_Number"
    Me.boxPName.AddItem "Part_Name"
    Me.boxPName.AddItem "Mat-No"
    Me.boxPName.AddItem "Remarks"
    Me.boxPName.AddItem "Material"
    Me.boxPName.AddItem "Type"
    Me.boxPName.AddItem "dimensions"
    
    ' erstes Element auswhlen
    Me.boxPName.ListIndex = 0
End Sub

Private Sub btnSearch_Click()
    Dim Selection1 As Selection
    Dim i As Integer
    Dim Param As Object
    Dim SearchString As String
    
    ' Suchliste leeren
    Me.boxFoundParams.Clear
    Set x = Nothing
    
    'On Error Resume Next
        Set Selection1 = CATIA.ActiveDocument.Selection
        Selection1.Clear
        
        ' Synchronisierung zwischen HSO(Highlighted Set of Objects) und CSO(Current Set of Objects) ausschalten
        CATIA.HSOSynchronized = False
        ' Suchen
        SearchString = Me.boxPName.Text
        If InStr(1, Me.boxPName.Text, "-") > 0 Then
            SearchString = "'" & SearchString & "'"
        End If
        Selection1.Search "(Name=*" & SearchString & " & CATKnowledgeSearch.InternalParameter),all"
        ' Synchronisierung zwischen HSO(Highlighted Set of Objects) und CSO(Current Set of Objects) wieder einschalten
        CATIA.HSOSynchronized = True
    
        ' alle gefundenen durchlaufen
        For i = 1 To Selection1.Count
            ' Parameter merken
            Set Param = Selection1.Item(i).Value
            ' nur wenn es der richtige Parameter ist
            ' z.B. Suche nach "Position" bringt auch "Remark_for_Position" als Ergebnis
            If InStr(1, UCase(Param.Name), UCase("\" & Me.boxPName.Text)) > 0 Then
                ' alle Parameter egal welcher Wert
                If txtValue.Text = "*" Then
                    ' Parameter in Liste aufnehmen
                    x.Add Param
                    Me.boxFoundParams.AddItem Param.Name
                End If
                ' ParameterWert = ""
                If txtValue.Text = "" And Param.ValueAsString = "" Then
                    ' Parameter in Liste aufnehmen
                    x.Add Param
                    Me.boxFoundParams.AddItem Param.Name
                End If
    
                ' ParameterWert  <> ""
                ' Gesuchter Wert <> ""
                ' ParameterWert  =  gesuchter Wert
                If Len(Param.ValueAsString) > 0 _
                And Len(txtValue.Text) > 0 _
                And InStr(1, Param.ValueAsString, txtValue.Text) > 0 Then
                    ' Parameter in Liste aufnehmen
                    x.Add Param
                    Me.boxFoundParams.AddItem Param.Name
                End If
            End If
        Next i
        ' Selection aufheben
        Selection1.Clear
        CATIA.StartCommand ("Collapse All")
        
        ' Variablen freigeben
        Set Selection1 = Nothing
        Set Param = Nothing
    On Error GoTo 0
End Sub

Private Sub boxFoundParams_Click()
    Dim Selection1 As Selection
    Set Selection1 = CATIA.ActiveDocument.Selection
    ' Selection aufheben
    Selection1.Clear
    
    ' gewhltes Element selectieren
    Selection1.Add x(Me.boxFoundParams.ListIndex + 1)
    
    ' im Baum auf selectiertes Element navigieren
    CATIA.StartCommand ("Collapse All")
    CATIA.StartCommand ("Center Graph")
    
    ' Variablen freigeben
    Set Selection1 = Nothing
End Sub

Private Sub btnExit_Click()
    ' Variable freigeben
    Set x = Nothing
    ' Formular schlieen
    Unload Me
End Sub

